#region Copyright Syncfusion Inc. 2001 - 2006
//
//  Copyright Syncfusion Inc. 2001 - 2006. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Diagram;
using STN.PMA.UL;
using System.IO;

namespace Syncfusion.Windows.Forms.Diagram.Samples.OrgChart
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel panel1;
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemUpdateLayout;
		private System.Windows.Forms.ImageList imageList1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemFileExit;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItemFile;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAdd;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemSelectTool;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemAutoLayout;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCut;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditCopy;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemEditPaste;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemHelpAbout;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem parentBarItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItemDimensions;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barAddCondition;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barAddRehab;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barAddCustomLink;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barSaveAs;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barOpen;
		private Syncfusion.Windows.Forms.Diagram.Samples.OrgChart.OrgChartManager orgChartManager;
		
		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            this.orgChartManager = new Syncfusion.Windows.Forms.Diagram.Samples.OrgChart.OrgChartManager();           
            this.orgChartManager.AutoLayout = false;
            this.orgChartManager.HorizontalSpacing = 200F;
            this.orgChartManager.VerticalSpacing = 140F;
            this.diagram.LayoutManager = this.orgChartManager;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		protected Link CreateOrthogonalLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.OrthogonalLine, pts);
			link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			return link;
		}

		protected Link CreateLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.Line, pts);
			link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			return link;
		}

		private bool mDisplayYesNo=false;
		protected Link CreateCustomLink(PointF[] pts)
		{
			Link link = new Link(Link.Shapes.Line, pts);
			link.EndPoints.LastEndPointDecorator = new EndPointDecorator(EndPointVisuals.ClosedArrow);
			// Links cannot be moved
			link.EditStyle.AllowMove = false;
			Syncfusion.Windows.Forms.Diagram.Label lblYesNo=link.AddLabel(clsConst.NO_VALUE,50);  //default label
			lblYesNo.Visible=mDisplayYesNo;
			lblYesNo.FontStyle.Style = System.Drawing.FontStyle.Bold;
			lblYesNo.BackgroundStyle.Color=System.Drawing.Color.Transparent;
			lblYesNo.Name=clsConst.YES_NO_LABEL_NAME;
			link.LineStyle.LineColor=clsConst.TREE_NO_COLOR;
			link.FillStyle.Color=clsConst.TREE_NO_COLOR;
			lblYesNo.FillStyle.Color=clsConst.TREE_NO_COLOR;
			
			this.diagram.View.SelectionList.Clear();  //otherwise the label will be selected
			return link;

		}


		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.panel1 = new System.Windows.Forms.Panel();
			this.diagram = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.mainFrameBarManager = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this.components, this);
			this.bar2 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "Actions");
			this.barItemSelectTool = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAdd = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemUpdateLayout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemAutoLayout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemDimensions = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "MainMenu");
			this.parentBarItemFile = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemFileExit = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemEditCut = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditCopy = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItemEditPaste = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.parentBarItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.ParentBarItem();
			this.barItemHelpAbout = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.barAddCondition = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barAddRehab = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barAddCustomLink = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barSaveAs = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barOpen = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.diagram)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.diagram.Model)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).BeginInit();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Controls.Add(this.diagram);
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 51);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(584, 411);
			this.panel1.TabIndex = 2;
			// 
			// diagram
			// 
			this.diagram.AllowDrop = true;
			// 
			// diagram.Controller
			// 
			this.diagram.Controller.MaxHistory = 256;
			this.diagram.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram.HScroll = true;
			this.diagram.LayoutManager = null;
			this.diagram.Location = new System.Drawing.Point(0, 0);
			// 
			// diagram.Model
			// 
			this.diagram.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram.Model.BackgroundStyle.ForeColor = System.Drawing.Color.White;
			this.diagram.Model.HeaderFooterData.Footer.Bounds.Width = 650F;
			this.diagram.Model.HeaderFooterData.Header.Bounds.Width = 650F;
			this.diagram.Model.MinimumSize = ((System.Drawing.SizeF)(resources.GetObject("diagram.Model.MinimumSize")));
			this.diagram.Model.Name = "Model";
			this.diagram.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.HighQuality;
			this.diagram.Model.ShadowStyle.AlphaFactor = 128;
			this.diagram.Model.ShadowStyle.Color = System.Drawing.Color.LightGray;
			this.diagram.Model.ShadowStyle.OffsetX = 6F;
			this.diagram.Model.ShadowStyle.OffsetY = 6F;
			this.diagram.Model.ShadowStyle.Visible = true;
			this.diagram.Name = "diagram";
			this.diagram.Size = new System.Drawing.Size(584, 411);
			this.diagram.SmartSizeBox = false;
			this.diagram.TabIndex = 1;
			this.diagram.Text = "OrgChart Diagram";
			// 
			// diagram.View
			// 
			this.diagram.View.Grid.Color = System.Drawing.Color.White;
			this.diagram.View.MouseTrackingEnabled = false;
			this.diagram.View.ShowPageBounds = true;
			this.diagram.VScroll = true;
			// 
			// mainFrameBarManager
			// 
			this.mainFrameBarManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("mainFrameBarManager.BarPositionInfo")));
			this.mainFrameBarManager.Bars.Add(this.bar2);
			this.mainFrameBarManager.Bars.Add(this.bar1);
			this.mainFrameBarManager.Categories.Add("Actions");
			this.mainFrameBarManager.Categories.Add("File");
			this.mainFrameBarManager.Categories.Add("Edit");
			this.mainFrameBarManager.Categories.Add("Help");
			this.mainFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form";
			this.mainFrameBarManager.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.mainFrameBarManager.Form = this;
			this.mainFrameBarManager.ImageList = this.imageList1;
			this.mainFrameBarManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											 this.barItemLink,
																											 this.barItemUpdateLayout,
																											 this.barItemFileExit,
																											 this.parentBarItemFile,
																											 this.barItemAdd,
																											 this.barItemSelectTool,
																											 this.barItemAutoLayout,
																											 this.barItemEditCut,
																											 this.barItemEditCopy,
																											 this.barItemEditPaste,
																											 this.barItemHelpAbout,
																											 this.parentBarItem1,
																											 this.parentBarItem2,
																											 this.barItemDimensions,
																											 this.barAddCondition,
																											 this.barAddRehab,
																											 this.barAddCustomLink,
																											 this.barSaveAs,
																											 this.barOpen});
			this.mainFrameBarManager.LargeImageList = null;
			this.mainFrameBarManager.ResetCustomization = false;
			// 
			// bar2
			// 
			this.bar2.BarName = "Actions";
			this.bar2.Caption = "Actions";
			this.bar2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItemSelectTool,
																							  this.barItemAdd,
																							  this.barAddCondition,
																							  this.barAddRehab,
																							  this.barAddCustomLink,
																							  this.barSaveAs,
																							  this.barOpen,
																							  this.barItemLink,
																							  this.barItemUpdateLayout,
																							  this.barItemAutoLayout,
																							  this.barItemDimensions});
			this.bar2.Manager = this.mainFrameBarManager;
			// 
			// barItemSelectTool
			// 
			this.barItemSelectTool.CategoryIndex = 0;
			this.barItemSelectTool.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemSelectTool.ID = "Select";
			this.barItemSelectTool.ImageIndex = 0;
			this.barItemSelectTool.Text = "Select";
			this.barItemSelectTool.Tooltip = "Select Tool";
			this.barItemSelectTool.Click += new System.EventHandler(this.barItemSelectTool_Click);
			// 
			// barItemAdd
			// 
			this.barItemAdd.CategoryIndex = 0;
			this.barItemAdd.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemAdd.ID = "Add";
			this.barItemAdd.ImageIndex = 1;
			this.barItemAdd.Text = "Add";
			this.barItemAdd.Tooltip = "Add Member";
			this.barItemAdd.Click += new System.EventHandler(this.barItemAdd_Click);
			// 
			// barItemLink
			// 
			this.barItemLink.CategoryIndex = 0;
			this.barItemLink.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemLink.ID = "Link";
			this.barItemLink.ImageIndex = 4;
			this.barItemLink.Text = "Link";
			this.barItemLink.Click += new System.EventHandler(this.barItemLink_Click);
			// 
			// barItemUpdateLayout
			// 
			this.barItemUpdateLayout.CategoryIndex = 0;
			this.barItemUpdateLayout.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemUpdateLayout.ID = "Update Layout";
			this.barItemUpdateLayout.ImageIndex = 5;
			this.barItemUpdateLayout.Text = "Update Layout";
			this.barItemUpdateLayout.Click += new System.EventHandler(this.barItemUpdateLayout_Click);
			// 
			// barItemAutoLayout
			// 
			this.barItemAutoLayout.CategoryIndex = 0;
			this.barItemAutoLayout.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemAutoLayout.ID = "AutoLayout";
			this.barItemAutoLayout.ImageIndex = 2;
			this.barItemAutoLayout.Text = "AutoLayout";
			this.barItemAutoLayout.Tooltip = "Auto Layout";
			this.barItemAutoLayout.Click += new System.EventHandler(this.barItemAutoLayout_Click);
			// 
			// barItemDimensions
			// 
			this.barItemDimensions.CategoryIndex = 0;
			this.barItemDimensions.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemDimensions.ID = "Dimensions";
			this.barItemDimensions.ImageIndex = 3;
			this.barItemDimensions.Text = "Dimensions";
			this.barItemDimensions.Click += new System.EventHandler(this.barItemDimensions_Click);
			// 
			// bar1
			// 
			this.bar1.BarName = "MainMenu";
			this.bar1.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.IsMainMenu) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder)));
			this.bar1.Caption = "MainMenu";
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.parentBarItemFile,
																							  this.parentBarItem1,
																							  this.parentBarItem2});
			this.bar1.Manager = this.mainFrameBarManager;
			// 
			// parentBarItemFile
			// 
			this.parentBarItemFile.CategoryIndex = 1;
			this.parentBarItemFile.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.parentBarItemFile.ID = "File";
			this.parentBarItemFile.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										   this.barItemFileExit});
			this.parentBarItemFile.Text = "File";
			// 
			// barItemFileExit
			// 
			this.barItemFileExit.CategoryIndex = 1;
			this.barItemFileExit.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemFileExit.ID = "Exit";
			this.barItemFileExit.Text = "Exit";
			this.barItemFileExit.Click += new System.EventHandler(this.barItemFileExit_Click);
			// 
			// parentBarItem1
			// 
			this.parentBarItem1.CategoryIndex = 2;
			this.parentBarItem1.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.parentBarItem1.ID = "Edit";
			this.parentBarItem1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItemEditCut,
																										this.barItemEditCopy,
																										this.barItemEditPaste});
			this.parentBarItem1.Text = "Edit";
			// 
			// barItemEditCut
			// 
			this.barItemEditCut.CategoryIndex = 2;
			this.barItemEditCut.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemEditCut.ID = "Cut";
			this.barItemEditCut.ImageIndex = 6;
			this.barItemEditCut.Shortcut = System.Windows.Forms.Shortcut.CtrlX;
			this.barItemEditCut.Text = "Cu&t";
			this.barItemEditCut.Click += new System.EventHandler(this.barItemEditCut_Click);
			// 
			// barItemEditCopy
			// 
			this.barItemEditCopy.CategoryIndex = 2;
			this.barItemEditCopy.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemEditCopy.ID = "Copy";
			this.barItemEditCopy.ImageIndex = 7;
			this.barItemEditCopy.Shortcut = System.Windows.Forms.Shortcut.CtrlC;
			this.barItemEditCopy.Text = "&Copy";
			this.barItemEditCopy.Click += new System.EventHandler(this.barItemEditCopy_Click);
			// 
			// barItemEditPaste
			// 
			this.barItemEditPaste.CategoryIndex = 2;
			this.barItemEditPaste.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemEditPaste.ID = "Paste";
			this.barItemEditPaste.ImageIndex = 8;
			this.barItemEditPaste.Shortcut = System.Windows.Forms.Shortcut.CtrlV;
			this.barItemEditPaste.Text = "&Paste";
			this.barItemEditPaste.Click += new System.EventHandler(this.barItemEditPaste_Click);
			// 
			// parentBarItem2
			// 
			this.parentBarItem2.CategoryIndex = 3;
			this.parentBarItem2.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.parentBarItem2.ID = "Help";
			this.parentBarItem2.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																										this.barItemHelpAbout});
			this.parentBarItem2.Text = "Help";
			// 
			// barItemHelpAbout
			// 
			this.barItemHelpAbout.CategoryIndex = 3;
			this.barItemHelpAbout.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barItemHelpAbout.ID = "About";
			this.barItemHelpAbout.Text = "About";
			this.barItemHelpAbout.Click += new System.EventHandler(this.barItemHelpAbout_Click);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Fuchsia;
			// 
			// barAddCondition
			// 
			this.barAddCondition.CategoryIndex = 0;
			this.barAddCondition.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barAddCondition.ID = "barAddCondition";
			this.barAddCondition.Text = "AddCondition";
			this.barAddCondition.Click += new System.EventHandler(this.barAddCondition_Click);
			// 
			// barAddRehab
			// 
			this.barAddRehab.CategoryIndex = 0;
			this.barAddRehab.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barAddRehab.ID = "barAddRehab";
			this.barAddRehab.Text = "AddRehab";
			this.barAddRehab.Click += new System.EventHandler(this.barAddRehab_Click);
			// 
			// barAddCustomLink
			// 
			this.barAddCustomLink.CategoryIndex = 0;
			this.barAddCustomLink.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barAddCustomLink.ID = "barAddCustomLink";
			this.barAddCustomLink.Text = "AddCustomLink";
			this.barAddCustomLink.Click += new System.EventHandler(this.barAddCustomLink_Click);
			// 
			// barSaveAs
			// 
			this.barSaveAs.CategoryIndex = 0;
			this.barSaveAs.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barSaveAs.ID = "SaveAs";
			this.barSaveAs.Text = "SaveAs...";
			this.barSaveAs.Click += new System.EventHandler(this.barSaveAs_Click);
			// 
			// barOpen
			// 
			this.barOpen.CategoryIndex = 0;
			this.barOpen.CustomTextFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.barOpen.ID = "barOpen";
			this.barOpen.Text = "Open...";
			this.barOpen.Click += new System.EventHandler(this.barOpen_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(584, 462);
			this.Controls.Add(this.panel1);
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Organizational Chart";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.diagram.Model)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.diagram)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			
			// Attach link object factory to the link tool
			Tool linkTool = this.diagram.Controller.GetTool("LinkTool");
			if (linkTool != null && linkTool.GetType() == typeof(LinkTool))
			{
#if false
				((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateOrthogonalLink);
#else
				((LinkTool)linkTool).LinkFactory = new LinkFactory(this.CreateLink);
#endif
			}

			this.barItemAutoLayout.Checked = this.orgChartManager.AutoLayout;
		}

		private void barItemLink_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("LinkTool");
		}

		private void barItemUpdateLayout_Click(object sender, System.EventArgs e)
		{
			this.diagram.LayoutManager.UpdateLayout(null);
		}

		private void barItemAdd_Click(object sender, System.EventArgs e)
		{
			OrgMemberInfoDlg infoDlg = new OrgMemberInfoDlg();
			if (infoDlg.ShowDialog(this) == DialogResult.OK)
			{
				MemberSymbol memSym = new MemberSymbol();
				memSym.MemberName = infoDlg.MemberName;
				memSym.Title = infoDlg.Title;
				this.diagram.Model.AppendChild(memSym);
				this.diagram.Model.UpdateViews();
			}
		}
		private void barAddCondition_Click(object sender, System.EventArgs e)
		{
			// 1 cond
			clsConditionSymbol symbol=new clsConditionSymbol();
			InsertSymbolTool tool=new InsertSymbolTool(this.diagram.Controller,"InsertCondition",typeof(clsConditionSymbol));
			this.diagram.Controller.RegisterTool(tool);
			this.diagram.Controller.ActivateTool(tool);
			tool.Symbol=symbol;
			this.diagram.Select();  // this make the the diagram to display symbol rectangle

			//pActiveToolBarItem=ActiveToolBarItems.Other;
		
		}

		private void barAddRehab_Click(object sender, System.EventArgs e)
		{
			// 1 result
			clsAlternativeSymbol symbol=new clsAlternativeSymbol();
			InsertSymbolTool tool=new InsertSymbolTool(this.diagram.Controller,"InsertResult",typeof(clsAlternativeSymbol));
			this.diagram.Controller.RegisterTool(tool);
			this.diagram.Controller.ActivateTool(tool);
			tool.Symbol=symbol;
			this.diagram.Select();  // this make the the diagram to display symbol rectangle

			//pActiveToolBarItem=ActiveToolBarItems.Other;
		}

		private void barSaveAs_Click(object sender, System.EventArgs e)
		{
			SaveAs();
		}

		private void barOpen_Click(object sender, System.EventArgs e)
		{
			Open();
		}
		private void barItemFileExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void barItemSelectTool_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("SelectTool");
		}

		private void barItemAutoLayout_Click(object sender, System.EventArgs e)
		{
			if (this.barItemAutoLayout.Checked)
			{
				this.barItemAutoLayout.Checked = false;
			}
			else
			{
				this.barItemAutoLayout.Checked = true;
			}
			this.orgChartManager.AutoLayout = this.barItemAutoLayout.Checked;
		}

		private void barItemEditCut_Click(object sender, System.EventArgs e)
		{
			this.diagram.Cut();
		}

		private void barItemEditCopy_Click(object sender, System.EventArgs e)
		{
			this.diagram.Copy();
		}

		private void barItemEditPaste_Click(object sender, System.EventArgs e)
		{
			this.diagram.Paste();
		}

		private void barItemDimensions_Click(object sender, System.EventArgs e)
		{
			DimensionsDlg dlg = new DimensionsDlg();

			dlg.DiagramWidth = this.diagram.Model.Width;
			dlg.DiagramHeight = this.diagram.Model.Height;

			if (dlg.ShowDialog(this) == DialogResult.OK)
			{
				this.diagram.Model.Width = dlg.DiagramWidth;
				this.diagram.Model.Height = dlg.DiagramHeight;
			}
		}

		private void barItemHelpAbout_Click(object sender, System.EventArgs e)
		{
			AboutForm about = new AboutForm();
			about.ShowDialog(this);
		}

		private void barAddCustomLink_Click(object sender, System.EventArgs e)
		{
		
			// unregister the previous linktool to clear memory
			LinkTool linkTool = this.diagram.Controller.GetTool("LinkTool") as LinkTool;
			if (linkTool!=null) this.diagram.Controller.UnRegisterTool(linkTool);
			//create new linktool
			linkTool = new LinkTool(this.diagram.Controller);
			linkTool.LinkFactory = new LinkFactory(this.CreateCustomLink);
		
			//register & activate new linktool
			this.diagram.Controller.RegisterTool(linkTool);
			this.diagram.Controller.ActivateTool(linkTool);
			this.diagram.Select();  // this make the the diagram to display symbol rectangle
		
		}

		private void SaveAs()
		{
			SaveFileDialog saveFileDialog1=new SaveFileDialog();
			saveFileDialog1.DefaultExt="edd";
			saveFileDialog1.Filter="Decision tree diagram files|*.edd";
			saveFileDialog1.FileName="Untitled.edd";
			
			if(saveFileDialog1.ShowDialog() == DialogResult.OK)
			{
				try
				{
					this.Refresh();

					string FileName=saveFileDialog1.FileName;
					string FileNameMin=Path.GetFileNameWithoutExtension(FileName)+".txt";
						
					if (File.Exists(FileName)) File.Delete(FileName);
					this.diagram.SaveBinary(FileName);	
					
					MessageBox.Show("saving '"+FileName+"' has been completed successfully.");
				}
				catch(Exception exp)
				{
					MessageBox.Show(exp.Message);
				}
			}	

		}

		private void Open()
		{
			

			// Open diagram
			OpenFileDialog openFileDialog1 =new OpenFileDialog();
			openFileDialog1.DefaultExt="edd";
			openFileDialog1.Filter="Decision tree diagram files|*.edd";
			openFileDialog1.FileName="Untitled.edd";
		
			if(openFileDialog1.ShowDialog() == DialogResult.OK)
			{				
				this.Refresh();

				string FileName=openFileDialog1.FileName;
				string FileNameMin=Path.GetFileNameWithoutExtension(FileName)+".txt";
				try
				{
					

					diagram.LoadBinary(FileName);
					diagram.Model.UpdateViews();
					diagram.Refresh();
					

				}
				catch (Exception exp)
				{
					MessageBox.Show(exp.Message);
				}

			}




		}

		

		
	}
}
