using System;
using Syncfusion.Windows.Forms.Diagram;
using System.Runtime.Serialization;
using System.Collections;
using System.Drawing;

namespace STN.PMA.UL
{
	/// <summary>
	/// Summary description for clsSymbol.
	/// </summary>
	[Serializable()]
	public class clsSymbol:Symbol
	{
		

		public clsSymbol()
		{
			
		}
		// Copy Constructor
		public clsSymbol(clsSymbol src) : base(src)
		{
			
		}
		protected clsSymbol(SerializationInfo info, StreamingContext context) : base(info, context)
		{

		}

		protected override void GetObjectData(SerializationInfo info, StreamingContext context)
		{
			base.GetObjectData(info, context);
		}

		protected override void OnDeserialization(object sender)
		{
			base.OnDeserialization(sender);
		}

		public int Rank
		{
			get
			{
				int rank = 1;

				IGraphNode thisNode = this as IGraphNode;
				IGraphNode curNode = thisNode;
				bool cyclicalPathFound = false;

				while (curNode != null && !cyclicalPathFound)
				{
					ICollection edgesEntering = curNode.EdgesEntering;
					if (edgesEntering.Count > 0)
					{
						IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
						if (enumEdgesEntering != null)
						{
							enumEdgesEntering.MoveNext();
							IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							if (incomingEdge != null)
							{
								curNode = incomingEdge.FromNode;

								if (curNode == thisNode)
								{
									cyclicalPathFound = true;
								}
								else
								{
									rank++;
								}
							}
						}
					}
					else
					{
						curNode = null;
					}
				}

				return rank;
			}
		}

		public string Condition(bool IncludeCurrNode)
		{
			return Condition(IncludeCurrNode,true);
		}

		public string Condition(bool IncludeCurrNode,bool YesNo)
		{
			
			int rank = 1;
			string sCond="";
			if (IncludeCurrNode)
			{
				clsConditionSymbol condSymThis = this as clsConditionSymbol;
				if (condSymThis!=null) 
				{
					if (condSymThis.Description.Trim()!="")
					{
						if (YesNo )
							sCond="["+condSymThis.Description+"] AND ";
						else
							sCond="NOT ["+condSymThis.Description+"] AND ";
					}
				}
			}
			IGraphNode thisNode = this as IGraphNode;
			IGraphNode curNode = thisNode;
			bool cyclicalPathFound = false;

			while (curNode != null && !cyclicalPathFound)
			{
				ICollection edgesEntering = curNode.EdgesEntering;
				if (edgesEntering.Count > 0)
				{
					IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
					if (enumEdgesEntering != null)
					{
						enumEdgesEntering.MoveNext();
						IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
						
						if (incomingEdge != null)
						{
							curNode = incomingEdge.FromNode;
							
							clsConditionSymbol condSym = curNode as clsConditionSymbol;
							if (condSym!=null)
							{
								Link lnk=enumEdgesEntering.Current as Link;
								if (lnk!=null) 
								{
									Label lbl=(Label) lnk.GetChildByName(clsConst.YES_NO_LABEL_NAME);
									if (lbl!=null)
									{
										if (condSym.Description.Trim()!="")
										{
											if (lbl.Text==clsConst.YES_VALUE)
												sCond="["+condSym.Description+"] AND "+sCond ;
											else
												sCond="NOT ["+condSym.Description+"] AND "+sCond ;
										}
									}
								}
								
							}
							if (curNode == thisNode)
							{
								cyclicalPathFound = true;
							}
							else
							{
								
								rank++;
							}
							
						}
					}
				}
				else
				{
					curNode = null;
				}
			}
			if (sCond!="") sCond=sCond.Substring(0,sCond.Length-5);
			return sCond;
		
		}

	
	public void SetPathColor(System.Drawing.Color PathColor)
		{
			   
				int rank = 1;
				string sCond="";
				clsAlternativeSymbol alterSymTmp=this as clsAlternativeSymbol;
				if (alterSymTmp!=null) 
				{
					
					alterSymTmp.rect.FillStyle.Color=PathColor;	
									
				}
				clsConditionSymbol condSymTmp=this as clsConditionSymbol;
				if (condSymTmp!=null) 
				{
					
					condSymTmp.rect.FillStyle.Color=PathColor;
									
				}

				IGraphNode thisNode = this as IGraphNode;
				IGraphNode curNode = thisNode;
				bool cyclicalPathFound = false;

				while (curNode != null && !cyclicalPathFound)
				{
					ICollection edgesEntering = curNode.EdgesEntering;
					if (edgesEntering.Count > 0)
					{
						IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
						if (enumEdgesEntering != null)
						{
							enumEdgesEntering.MoveNext();
							IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							
							if (incomingEdge != null)
							{
								curNode = incomingEdge.FromNode;
								
								clsConditionSymbol condSym = curNode as clsConditionSymbol;
								if (condSym!=null)
								{
									
									condSym.rect.FillStyle.Color=PathColor;
									
									Link lnk=enumEdgesEntering.Current as Link;

									if (lnk!=null) 
									{
										lnk.FillStyle.Color=PathColor;
										Label lbl=(Label) lnk.GetChildByName(clsConst.YES_NO_LABEL_NAME);
										if (lbl!=null)
										{
											lbl.FillStyle.Color=PathColor;
											if (lbl.Text==clsConst.YES_VALUE)
											{
												sCond="["+condSym.Description+"] AND "+sCond ;
											}
											else
											{
												sCond="NOT ["+condSym.Description+"] AND "+sCond ;
											}
										}
									}
									
								}
								if (curNode == thisNode)
								{
									cyclicalPathFound = true;
								}
								else
								{
									
									rank++;
								}
								
							}
						}
					}
					else
					{
						curNode = null;
					}
				}
				if (sCond!="") sCond=sCond.Substring(0,sCond.Length-5);
		}


		public void ResetPathColor()
		{
			   
			clsAlternativeSymbol alterSymTmp=this as clsAlternativeSymbol;
			if (alterSymTmp!=null) 
			{
				alterSymTmp.rect.FillStyle.Color=clsConst.TREE_ALTERNATIVE_COLOR;					
			}
			clsConditionSymbol condSymTmp=this as clsConditionSymbol;
			if (condSymTmp!=null) 
			{
				condSymTmp.rect.FillStyle.Color=clsConst.TREE_CONDITION_COLOR;						
			}

			IGraphNode thisNode = this as IGraphNode;
			IGraphNode curNode = thisNode;
			bool cyclicalPathFound = false;

			while (curNode != null && !cyclicalPathFound)
			{
				ICollection edgesEntering = curNode.EdgesEntering;
				if (edgesEntering.Count > 0)
				{
					IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
					if (enumEdgesEntering != null)
					{
						enumEdgesEntering.MoveNext();
						IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							
						if (incomingEdge != null)
						{
							curNode = incomingEdge.FromNode;
								
							clsConditionSymbol condSym = curNode as clsConditionSymbol;
							if (condSym!=null)
							{
									
								condSym.rect.FillStyle.Color=clsConst.TREE_CONDITION_COLOR;
										

								Link lnk=enumEdgesEntering.Current as Link;

								if (lnk!=null) 
								{
									Label lbl=(Label) lnk.GetChildByName(clsConst.YES_NO_LABEL_NAME);
									if (lbl!=null)
									{
										if (lbl.Text==clsConst.YES_VALUE)
										{
										
											lnk.FillStyle.Color=clsConst.TREE_YES_COLOR;
											lbl.FillStyle.Color=clsConst.TREE_YES_COLOR;

										}
										else
										{
										
											lnk.FillStyle.Color=clsConst.TREE_NO_COLOR;
											lbl.FillStyle.Color=clsConst.TREE_NO_COLOR;
										}
									}
								}
									
							}
							if (curNode == thisNode)
							{
								cyclicalPathFound = true;
							}
								
						}
					}
				}
				else
				{
					curNode = null;
				}
			}
		}

		public ICollection Employees
		{
			get
			{
				ArrayList employees = new ArrayList();

				IGraphNode thisNode = this as IGraphNode;

				if (thisNode != null)
				{
					ICollection edgesLeaving = thisNode.EdgesLeaving;
					if (edgesLeaving != null)
					{
						foreach (IGraphEdge curEdge in edgesLeaving)
						{
							clsSymbol curEmployee = curEdge.ToNode as clsSymbol;
							if (curEmployee != null)
							{
								employees.Add(curEmployee);
							}
						}
					}
				}

				return employees;
			}
		}
		// Creates a new object that is a copy of the current instance.	
		// An override of the Clone method is required for clipboard copy/paste.
		public override object Clone()
		{
			return new clsSymbol(this);
		}	
		public clsSymbol Manager
		{
			get
			{
				clsSymbol manager = null;
				IGraphNode thisNode = this as IGraphNode;
				IGraphNode fromNode;

				if (thisNode != null)
				{
					ICollection edgesEntering = thisNode.EdgesEntering;
					if (edgesEntering.Count > 0)
					{
						IEnumerator enumEdgesEntering = edgesEntering.GetEnumerator();
						if (enumEdgesEntering != null)
						{
							enumEdgesEntering.MoveNext();
							IGraphEdge incomingEdge = enumEdgesEntering.Current as IGraphEdge;
							if (incomingEdge != null)
							{
								fromNode = incomingEdge.FromNode;

								if (fromNode != null)
								{
									manager = fromNode as clsSymbol;
								}
							}
						}
					}
				}

				return manager;
			}
		}


	
		public override void Translate(float dx, float dy)
		{
			// TODO:  Add clsSymbol.Translate implementation
			base.Translate (dx, dy);
		}
	}
}
